"""Add station module"""
import os
import sys
from PyQt5.QtWidgets import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from . import paths


class Add_Station(QDialog):
	"""Add station class"""
	def __init__(self, parentWidget):
		super().__init__()
		self.parentWidget = parentWidget
		self.create_widgets()

	def create_widgets(self):
		"""Create widgets"""
		#vbox main
		self.vbox_main = QVBoxLayout()
		self.setLayout(self.vbox_main)
		
		#form_layout
		self.form_layout = QFormLayout()
		self.vbox_main.addLayout(self.form_layout)
		
		#widgets
		self.entry_name = QLineEdit(self)
		self.entry_stream = QLineEdit()
		#add rows
		self.form_layout.addRow(self.tr("Enter name of station: "), self.entry_name)
		self.form_layout.addRow(self.tr("Put your stream: "), self.entry_stream)
		
	#add label added
		self.label_added_station = QLabel()
		self.label_added_station.setAlignment(Qt.AlignCenter)
		self.label_added_station.setStyleSheet("color:blue")
		self.label_added_station.setWordWrap(True)
		self.vbox_main.addWidget(self.label_added_station)

	#add stretch
		self.vbox_main.addStretch()

	#add button OK
		self.button_ok = QPushButton(self.tr("Add to Favs"))
		self.button_ok.setMinimumHeight(30)
		self.button_ok.setStyleSheet(paths.BUTTONS_STYLE)
		self.button_ok.setCursor(Qt.PointingHandCursor)
		self.button_ok.clicked.connect(self.press_save)
		self.vbox_main.addWidget(self.button_ok)

		#set up
		self.resize(500, 250)
		self.setAttribute(Qt.WA_DeleteOnClose, True)
		self.setModal(True)
		self.setWindowTitle(self.tr("Add station"))
		self.show()

############################################################################################

	def set_name_url(self, name, url):
		"""Set name url"""
		self.entry_name.setText(name.strip())
		self.entry_stream.setText(url.strip())
		
	def press_save(self):
		"""Press save"""
		name_station = self.entry_name.text()
		stream = self.entry_stream.text()
		if name_station and stream:
			save_params = [name_station, stream, '']
			paths.BASE_CURSOR.execute("INSERT INTO favs VALUES(?,?,?)", save_params)
			paths.BASE_CONNECTION.commit()
			self.label_added_station.clear()
			self.label_added_station.setText(self.tr("The station ") + name_station + self.tr(" was added."))
			self.entry_name.clear()
			self.entry_stream.clear()
			self.parentWidget.fav_tab.add_one_row(name_station, stream)
