from PyQt5.QtWidgets import *
from PyQt5.QtGui import *
from PyQt5.QtCore import *
import os
from . import paths

class AddCh(QWidget):
	def __init__(self):
		super().__init__()
		self.create_widgets()
		
	def create_widgets(self):
		
		self.vbox_main = QVBoxLayout()
		self.setLayout(self.vbox_main)
		
		#check label
		self.check_label = QLabel()
		self.check_label.setAlignment(Qt.AlignCenter)
		self.check_label.setWordWrap(True)
		self.vbox_main.addWidget(self.check_label)
		
		
		#add line id
		self.line_id = QLineEdit()
		self.line_id.textChanged.connect(self.change_text_id)
		self.line_id.setPlaceholderText("id")
		self.vbox_main.addWidget(self.line_id)
		
		#add line name
		self.line_name = QLineEdit()
		self.line_name.setPlaceholderText("name")
		self.vbox_main.addWidget(self.line_name)
		
		#add line web_num
		self.line_web_num = QLineEdit()
		self.line_web_num.setPlaceholderText("web num")
		self.vbox_main.addWidget(self.line_web_num)
		
		#add line web_num
		self.line_image = QLineEdit()
		self.line_image.setPlaceholderText("image")
		self.vbox_main.addWidget(self.line_image)
		
		
		#add combo_lands
		self.combo_lands = QComboBox()
		self.vbox_main.addWidget(self.combo_lands)
		lands = ["Ukraine","Russia",]
		for item in lands:
			self.combo_lands.addItem(item)
		
		
		self.vbox_main.addStretch()
		
		#button check
		self.button_check = QPushButton("Check")
		self.button_check.setStyleSheet(paths.BUTTONS_STYLE)
		self.button_check.setCursor(Qt.PointingHandCursor)
		self.button_check.setMinimumHeight(30)
		self.button_check.clicked.connect(self.check_in_base)
		self.vbox_main.addWidget(self.button_check)
		
		#button save
		self.button_save = QPushButton("Save")
		self.button_save.clicked.connect(self.press_save_button)
		self.vbox_main.addWidget(self.button_save)
		
		#button add_ll
		#self.button_add_all = QPushButton("add all")
		#self.button_add_all.clicked.connect(self.press_add_all_button)
		#self.vbox_main.addWidget(self.button_add_all)
		
		###
		self.resize(200, 250)
		self.show()
		
#################################################################################################

	def check_in_base(self):
		
		self.check_label.clear()
		
		current_id = self.line_id.text()
		current_num = self.line_web_num.text()
		
		id_search = [current_id,]
		paths.CH_CURSOR.execute("SELECT * FROM channels WHERE ch_id=(?)", id_search)
		id_found_result = paths.CH_CURSOR.fetchone()
		
		
		num_search = [current_num,]
		paths.CH_CURSOR.execute("SELECT * FROM channels WHERE ch_num=(?)", num_search)
		num_found_result = paths.CH_CURSOR.fetchone()
		
		if id_found_result or num_found_result:
			if id_found_result:
				self.check_label.setText("Exists already - {0} - {1} - {2}".format(id_found_result[0], id_found_result[1], id_found_result[2]))
			if num_found_result:
				self.check_label.setText("Exists already - {0} - {1} - {2}".format(num_found_result[0], num_found_result[1], num_found_result[2]))
			self.check_label.setStyleSheet("QLabel{color:red; font-weight:bold;}")
		else:
			self.check_label.setText("Free")
			self.check_label.setStyleSheet("QLabel{color:blue; font-weight:bold;}")
		

	def change_text_id(self, text):
		
		self.line_image.setText(text)


	def press_save_button(self):
		
		ch_id = self.line_id.text()
		ch_name = self.line_name.text().lower()
		web_num = self.line_web_num.text()
		image = self.line_image.text()
		land = self.combo_lands.currentText()
		
		if ch_id and ch_name and web_num and image:
			
			paths.CH_CURSOR.execute("SELECT ch_num FROM channels")
			all_base_ids = paths.CH_CURSOR.fetchall()

			if not (web_num,) in all_base_ids:
			
				insert_params = [ch_id, ch_name, web_num, image, land]
				
				
				paths.CH_CURSOR.execute("INSERT INTO channels VALUES(?,?,?,?,?)", insert_params)
				paths.CH_CONNECTION.commit()
				
				
				self.line_id.clear()
				self.line_name.clear()
				self.line_web_num.clear()
				self.line_image.clear()
		


	#def press_add_all_button(self):
		
		#UKR_LIST = [
			#("1p1","1+1","3","1plus1.gif","Ukraine",),
			#("ictv","ICTV","5","ictv.gif","Ukraine",),
			#("k1","К1","19","k1.gif","Ukraine",),
			#("ntn","НТН","212","ntn.gif","Ukraine",),
			#("sonce","Сонце","874","sonce.gif","Ukraine",),
			#("stb","СТБ","6","stb.gif","Ukraine",),
			#("inter","Інтер","4","inter.gif","Ukraine",),
			#("noviy kanal","Новий канал","7","noviy.gif","Ukraine",),
			#("2p2","2+2","23","2plus2.gif","Ukraine",),
			#("tet","ТЕТ","18","tet.jpg","Ukraine",),
			#("ukraina","Украина","108","trkukraina.gif","Ukraine",),
			#("khersonplus","Херсон плюс","1172","khersonplus.gif","Ukraine",),
			#("mega","Мега","234","mega.gif","Ukraine",),
			#("kanal5ua","5 канал","106","5ch.gif","Ukraine",),
			#("enterfilm","Enter-фильм","92","enterfilm.gif","Ukraine",),
			#("pershiyua","Перший","540","pershiy.gif","Ukraine",),
			#("zoom","Zoom","353","zoom.gif","Ukraine",),
			#("bigudi","Бигуди","481","bigydi.gif","Ukraine",),
			#("indigo","Індиго","1002","indigo.gif","Ukraine",),
			#("k2","К2","20","k2.gif","Ukraine",),
			#("malyatko","Малятко","606","malyatko.gif","Ukraine",),
			#("piksel","Пиксель","27","pixel.gif","Ukraine",),
			#("plusplus","Плюс Плюс","24","plusplus.gif","Ukraine",),
			#("112ua","112","921","112ukraine.gif","Ukraine",),
			#("sportua","Спорт","270","sport_ua.gif","Ukraine",),
			#("m1","М1","94","m1.gif","Ukraine",),
			#("oce","Оце","460","oce.gif","Ukraine",),
		#]
		
		#for item in UKR_LIST:
		
		
		#RUS_LIST = [
			#("perviyru","Первый","8","perviy_russia.gif","Russia",),
			#("russia1", "Россия 1","9","russia1.gif","Russia",),
			#("sts","СТС","17","sts.gif","Russia",),
			#("tv3","ТВ3","63","tv3.gif","Russia",),
			#("tnt","ТНТ","14","tnt.gif","Russia",),
			#("mir","Мир","176","mir.gif","Russia",),
			#("ntv","НТВ","10","ntv.gif","Russia",),
			#("2x2","2x2","341","2x2.gif","Russia",),
			#("detskiy","Детский","246","detskiy.gif","Russia",),
			#("domashniy","Домашний","124","home.gif","Russia",),
			#("disney","Disney","89","disney.gif","Russia",),
			#("karusel","Карусель","687","karusel.gif","Russia",),
			#("kultura","Культура","15","kultura.gif","Russia",),
			#("boets","Боец","310","matchboec.gif","Russia",),
			#("nostalgiya","Ностальгия","216","nostalgiya.gif","Russia",),
			#("fox","Fox","413","fox.gif","Russia",),
			#("nickelodeon","Nickelodeon","45","nickelodeon.gif","Russia",),
			#("sonyscifi","Sony Sci-fi","403","sonyscifi.gif","Russia",),
			#("nst","НСТ","329","nst.gif","Russia",),
			#("rentv","Рен ТВ","13","rentv.gif","Russia",),
			#("russia24","Россия 24","328","russia24.gif","Russia",),
			#("sarafan","Сарафан","433","sarafan.gif","Russia",),
			#("tvc","ТВЦ","11","tvc.gif","Russia",),
			#("sony","Sony","525","sony.gif","Russia",),
			#("pyatnica","Пятница","48","pyatnica.gif","Russia",),
			#("domkino","Дом кино","302","homekino.gif","Russia",),
			#("multimania","Мульти-мания","286","multimania_rus.gif","Russia",),
			#("lale","Lale","911","lale.gif","Russia",),
			#("kinotv","КиноТВ","852","kinotv.gif","Russia",),
			#("rusnight","Русская ночь","296","rus_night.gif","Russia",),
			#("rusbest","Русский бест-лер","812","rus_best.gif","Russia",),
			#("rusdet","Русский детектив","942","rus_det.gif","Russia",),
			#("rusroman","Русский роман","757","rus_rom.gif","Russia",),
	#]
		
		#for item in RUS_LIST:
			#ch_id = item[0]
			#ch_name = item[1].lower()
			#web_num = item[2]
			#image = item[3]
			#land = item[4]
			
			#insert_params = [ch_id, ch_name, web_num, image, land]
			
			
			#paths.CH_CURSOR.execute("INSERT INTO channels VALUES(?,?,?,?,?)", insert_params)
			#paths.CH_CONNECTION.commit()
