"""Save WEB PLS module"""
import os
from PyQt5.QtWidgets import QDialog, QVBoxLayout, QPushButton, QLineEdit, QLabel
from PyQt5.QtCore import Qt
from . import paths


class Create_pls(QDialog):
	"""Create_pls class"""
	def __init__(self):
		super().__init__()
		self.create_widgets()

	def create_widgets(self):
		"""Create widgets"""
		self.SAVE_URL = None
	#vbox main
		self.vbox_main = QVBoxLayout()
		self.setLayout(self.vbox_main)
		
		#name line
		self.pls_name_line = QLineEdit()
		self.pls_name_line.setPlaceholderText(self.tr("Name of playlist"))
		self.vbox_main.addWidget(self.pls_name_line)
		#label_path
		self.label_save_path = QLabel()
		self.label_save_path.setWordWrap(True)
		self.vbox_main.addWidget(self.label_save_path)
		#
		self.vbox_main.addStretch()
		
		#button_ok
		self.button_ok = QPushButton("Save")
		self.button_ok.setStyleSheet(paths.BUTTONS_STYLE)
		self.button_ok.setFixedHeight(30)
		self.button_ok.setCursor(Qt.PointingHandCursor)
		self.button_ok.clicked.connect(self.press_save_button)
		self.vbox_main.addWidget(self.button_ok)
		
		#set main
		self.resize(300, 200)
		self.setModal(True)
		self.setWindowTitle(self.tr("Save WEB url"))
		
######################################################################################################

	def press_save_button(self):
		"""Press save"""
		name = self.pls_name_line.text()
		if name:
			name = "(URL)_{0}.txt".format(name)
			full_path = os.path.join(paths.path_playlists, name)
			with open(full_path, 'w') as file_save:
				file_save.write(self.SAVE_URL)
			self.label_save_path.setText("Saved to {0}".format(full_path))
