from PyQt5.QtCore import QDate, QCoreApplication
import bs4, re, os
from bs4 import BeautifulSoup
import urllib.parse
import urllib.request
from urllib.request import Request, urlopen
from . import paths

def get_url(name, *args):
	info = ""
	try:
		name = name.lower()
		search_params = [name,]
		paths.CH_CURSOR.execute("SELECT * FROM channels WHERE ch_name=(?)", search_params)
		ch_num = paths.CH_CURSOR.fetchone()[2]
		current_date = QDate().currentDate().toString("yyyy-MM-dd")
		site_template = "http://www.vsetv.com/schedule_channel_{0}_day_{1}_ft_all.html"
		url = site_template.format(ch_num, current_date)
		QCoreApplication.processEvents()
		req = Request(url, headers={'User-Agent': 'Mozilla/5.0'})
		QCoreApplication.processEvents()
		webpage = urlopen(req).read()
		QCoreApplication.processEvents()
		soup = BeautifulSoup(webpage, "html.parser")
		info = parse_vsetv(soup)
	except:
		info = ""
	return info
	

def parse_vsetv(soup):
	current_program = ""
	try:
		need_class = re.compile(".*time|onair")
		need_name_class = re.compile(".*prname2")
		QCoreApplication.processEvents()
		all_time_divs = soup.find_all("div", attrs={"class":need_class})
		all_name_divs = soup.find_all("div", attrs={"class":need_name_class})
		QCoreApplication.processEvents()
		onair_div = soup.find("div", attrs={"class":re.compile("onair")})
		onair_index = all_time_divs.index(onair_div)
		
		current_program = all_name_divs[onair_index].text
	except:
		current_program = ""
	
	return current_program
