from PyQt5.QtWidgets import *
from PyQt5.QtGui import *
from PyQt5.QtCore import *
from . import paths

class HowtoWin(QDialog):
	def __init__(self):
		super().__init__()
		self.create_widgets()
		
	def create_widgets(self):
		
		self.vbox_main = QVBoxLayout()
		self.vbox_main.setContentsMargins(0,0,0,0)
		self.setLayout(self.vbox_main)
		
		font = QFont()
		font.setPointSize(14)
		#add text browser
		self.text_browser = QTextBrowser()
		self.text_browser.setFont(font)
		self.text_browser.setWordWrapMode(QTextOption.WordWrap)
		self.text_browser.setSource(QUrl(paths.howto_index))
		self.text_browser.setOpenLinks(False)
		self.text_browser.anchorClicked.connect(self.click_text_anchor)
		self.vbox_main.addWidget(self.text_browser)
		
		###
		self.resize(900,600)
		self.setWindowTitle("?")
		self.setWindowIcon(QIcon(paths.howto_icon))
		self.setModal(True)
		
########################################################################################


	def click_text_anchor(self, qurl):
		"""Scroll to anchor"""
		self.text_browser.scrollToAnchor(qurl.url())
		
	def closeEvent(self, event):
		"""Close event"""
		self.text_browser.deleteLater()
		self.deleteLater()
