from PyQt5.QtWidgets import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
import os
from . import paths


class New_pls(QDialog):
	def __init__(self):
		super().__init__()
		self.create_widgets()

	def create_widgets(self):

		self.vbox_main = QVBoxLayout()
		self.vbox_main.setContentsMargins(0,0,0,0)
		self.setLayout(self.vbox_main)


		#add tabber
		self.tabber = QTabWidget()
		self.tabber.tabBarClicked.connect(self.press_tabBar)
		self.vbox_main.addWidget(self.tabber)

		#add tabs
		self.tab_create = Create_pls()
		self.tab_add = Add_url()
		self.tabber.addTab(self.tab_create, self.tr("Create new Pls"))
		self.tabber.addTab(self.tab_add, self.tr("Add url"))


		self.resize(400,300)
		self.setModal(True)
		self.setWindowTitle(self.tr("Create new Playlist"))
		self.show()


	def press_tabBar(self, tab):
		if tab == self.tabber.indexOf(self.tab_add):
			self.tab_add.create_pls_list()

######################################################################################################
###########################################################################################################

class Create_pls(QWidget):
	def __init__(self):
		super().__init__()
		self.create_widgets()


	def create_widgets(self):

		self.vbox_main = QVBoxLayout()
		self.setLayout(self.vbox_main)


		#line
		self.line_name_pls = QLineEdit()
		self.line_name_pls.setPlaceholderText(self.tr("Name"))
		self.vbox_main.addWidget(self.line_name_pls)


		#stretch
		self.vbox_main.addStretch()


		#button
		self.button_create = QPushButton(self.tr("Create new playlist"))
		self.button_create.setMinimumHeight(25)
		self.button_create.setMinimumWidth(40)
		self.button_create.setCursor(Qt.PointingHandCursor)
		self.button_create.setStyleSheet(paths.BUTTONS_STYLE)
		self.button_create.clicked.connect(self.press_create_button)
		self.vbox_main.addWidget(self.button_create)



	def press_create_button(self):

		name = self.line_name_pls.text()

		if len(name) > 0:
			name = name + ".m3u"
			path_pls = paths.path_playlists
			full_pls_path = os.path.join(path_pls, name)
			if not os.path.exists(full_pls_path):
				new_pls = open(full_pls_path, "w")
				self.line_name_pls.clear()
				new_pls.close()

###########################################################################################################
###########################################################################################################

class Add_url(QWidget):
	def __init__(self):
		super().__init__()
		self.create_widgets()


	def create_widgets(self):

		self.vbox_main = QVBoxLayout()
		self.setLayout(self.vbox_main)
		
		
	#main_label
		self.label_main = QLabel()
		self.label_main.setWordWrap(True)
		self.vbox_main.addWidget(self.label_main)


	#list pls
		self.combo_playlists = QComboBox()
		self.combo_playlists.activated.connect(self.choose_main_pls)
		self.vbox_main.addWidget(self.combo_playlists)
		
	#combo_sub_folder_items
		self.combo_sub_folder_items = QComboBox()
		self.combo_sub_folder_items.hide()
		self.combo_sub_folder_items.activated.connect(self.change_sub_folder_pls)
		self.vbox_main.addWidget(self.combo_sub_folder_items)

		
		self.create_pls_list()


		#line name
		self.line_name = QLineEdit()
		self.line_name.setPlaceholderText(self.tr("Name"))
		self.vbox_main.addWidget(self.line_name)

		#line url
		self.line_url = QLineEdit()
		self.line_url.setPlaceholderText("Url")
		self.vbox_main.addWidget(self.line_url)


		#stretch
		self.vbox_main.addStretch()

		#hbox add-edit
		self.hbox_add_edit = QHBoxLayout()
		self.vbox_main.addLayout(self.hbox_add_edit)
		#button add
		self.button_add = QPushButton(self.tr("Add new url"))
		self.button_add.setMinimumHeight(25)
		self.button_add.setMinimumWidth(40)
		self.button_add.setCursor(Qt.PointingHandCursor)
		self.button_add.setStyleSheet(paths.BUTTONS_STYLE)
		self.button_add.clicked.connect(self.press_add_button)
		self.hbox_add_edit.addWidget(self.button_add)


#####################################################################################################

	def change_sub_folder_pls(self):
		
		current_pls = self.combo_sub_folder_items.currentText()
		folder = os.path.join(paths.path_playlists, self.combo_playlists.currentText())
		full_path = os.path.join(folder, current_pls)
		self.label_main.setText(full_path)

	def choose_main_pls(self):
		self.combo_sub_folder_items.clear()
		if self.combo_playlists.currentIndex() > 0:
			current_main_pls = self.combo_playlists.currentText()
			full_path = os.path.join(paths.path_playlists, current_main_pls)
			if os.path.isdir(full_path) and len(os.listdir(full_path)) > 1:
				list_sub_items = os.listdir(full_path)
				for item in list_sub_items:
					full_sub_item_path = os.path.join(full_path, item)
					if os.path.isfile(full_sub_item_path):
						if not QFileInfo(full_sub_item_path).isHidden():
							if "(URL)" in item:
								self.combo_sub_folder_items.addItem(QIcon(paths.url_icon), item)
							else:
								self.combo_sub_folder_items.addItem(QIcon(paths.sub_pls_icon), item)
				self.combo_sub_folder_items.show()
			else:
				self.combo_sub_folder_items.hide()
				self.combo_sub_folder_items.clear()
				
			self.label_main.setText(full_path)
		else:
			self.label_main.clear()
			self.combo_sub_folder_items.hide()
			if self.combo_sub_folder_items.isVisible():
				self.combo_sub_folder_items.clear
				

	def create_pls_list(self):
		self.combo_playlists.clear()
		playlists_list = os.listdir(paths.path_playlists)
		playlists_list.sort()
		self.combo_playlists.addItem(self.tr("Choose:"))
		for item in playlists_list:
			full_path_item = os.path.join(paths.path_playlists, item)
			if os.path.isdir(full_path_item):
				if not QFileInfo(full_path_item).isHidden():
					self.combo_playlists.addItem(QIcon(paths.folder_icon), item)
		for item in playlists_list:
			full_path_item = os.path.join(paths.path_playlists, item)
			if os.path.isfile(full_path_item):
				if not QFileInfo(full_path_item).isHidden():
					self.combo_playlists.addItem(QIcon(paths.pls_icon), item)


	def press_add_button(self):

		name = self.line_name.text()
		url = self.line_url.text()
		
		if len(name) > 0 and len(url) > 0 and self.combo_playlists.currentIndex() > 0:
		
			current_playlist = self.combo_playlists.currentText()
			full_pls_path = os.path.join(paths.path_playlists, current_playlist)
			
			if os.path.isdir(full_pls_path):
				sub_playlist = self.combo_sub_folder_items.currentText()
				full_pls_path = os.path.join(full_pls_path, sub_playlist)

			
				
			file_pls = open(full_pls_path, "a")
			file_pls.write(("#EXTINF: ," + name + "\n"))
			file_pls.write(url + "\n")
			self.line_name.clear()
			self.line_url.clear()
			
			
