import bs4, re
from bs4 import BeautifulSoup
import urllib.parse
import urllib.request
from urllib.request import Request, urlopen


def get_url(url):
	info_list = []
	
	req = Request(url, headers={'User-Agent': 'Mozilla/5.0'})
	webpage = urlopen(req).read()
	soup = BeautifulSoup(webpage, "html.parser")
	
	if "vsetv" in url:
		info_list = parse_vsetv(soup)
		
		
	return info_list
	

def parse_vsetv(soup):
	info_list = []
	
	need_class = re.compile(".*time|onair")
	need_name_class = re.compile(".*prname2")
	
	all_time_divs = soup.find_all("div", attrs={"class":need_class})
	all_name_divs = soup.find_all("div", attrs={"class":need_name_class})
	
	#onair_div = soup.find("div", attrs={"class":re.compile("onair")})
	#onair_index = all_time_divs.index(onair_div)

	for x in range(len(all_time_divs)):
		if "onair" in str(all_time_divs[x]):
			onair_index = 1
		else:
			onair_index = 0
		time_text = all_time_divs[x].text.strip()
		name = all_name_divs[x].text.strip()
		
		info_list.append((time_text, name, onair_index))
	
	return info_list
	
	
	
