"""Tv main module"""
from PyQt5.QtWidgets import QDialog, QVBoxLayout, QTabWidget, QTabBar, QLabel
from PyQt5.QtGui import QIcon
from PyQt5.QtCore import Qt
from . import tvMain


class Tvgid(QDialog):
	def __init__(self):
		super().__init__()
		self.create_widgets()
		
	def create_widgets(self):
		"""Create widgets"""
		#vbox main
		self.vbox_main = QVBoxLayout()
		self.vbox_main.setContentsMargins(1,1,1,1)
		self.setLayout(self.vbox_main)
		
		#tabber
		self.tabber = QTabWidget()
		self.tabber.setTabsClosable(True)
		self.tabber.tabCloseRequested.connect(self.press_close_tab)
		self.vbox_main.addWidget(self.tabber)
		#add tv tab
		self.main_tab = tvMain.TvMain()
		self.tabber.addTab(self.main_tab, self.tr("All"))
		
		###
		self.setAttribute(Qt.WA_DeleteOnClose, True)
		self.setWindowIcon(QIcon("icons/tv/tvgid_icon.png"))
		self.setWindowTitle("ZVVTvGid")
		self.resize(480, 500)
		self.setModal(True)
		self.tabber.tabBar().setTabButton(0, QTabBar.RightSide, QLabel())
		
##########################################################################################

	def press_close_tab(self, index):
		"""Close tab"""
		current_widget = self.tabber.widget(index)
		current_widget.table_view.setRowCount(0)
		current_widget.close()
		self.tabber.removeTab(index)
		
	def add_tab(self, widget, name):
		"""Add tab"""
		self.tabber.addTab(widget, name)
		self.tabber.setCurrentIndex(self.tabber.count() - 1)
		self.main_tab.label_load.hide()
		
###########################################################################################

	def closeEvent(self, event):
		"""Close event"""
		self.main_tab.list_widget.clear()
		self.deleteLater()
